Bug 1936138 - Review Request: wyhash - No hash function is perfect, but some are useful
Summary: Review Request: wyhash - No hash function is perfect, but some are useful
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Antonio T. sagitter
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2021-03-06 23:00 UTC by Ben Beasley
Modified: 2021-03-27 00:29 UTC (History)
1 user (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-03-11 12:41:20 UTC
Type: ---
trpost: fedora-review+


Attachments (Terms of Use)

Description Ben Beasley 2021-03-06 23:00:36 UTC
Spec URL: https://music.fedorapeople.org/wyhash.spec
SRPM URL: https://music.fedorapeople.org/wyhash-final1-1.20210306gitfinal.fc33.src.rpm

Description: 

No hash function is perfect, but some are useful.

wyhash and wyrand are the ideal 64-bit hash function and PRNG respectively:

solid: wyhash passed SMHasher, wyrand passed BigCrush, practrand.

portable: 64-bit/32-bit system, big/little endian.

fastest: Efficient on 64-bit machines, especially for short keys.

simplest: In the sense of code size.

This package provides version “final1” of wyhash.

Fedora Account System Username: music

This is a simple header-only C library (https://docs.fedoraproject.org/en-US/packaging-guidelines/#_packaging_header_only_libraries) that has somewhat awkward versioning, which I think I have handled reasonably.

Comment 1 Antonio T. sagitter 2021-03-08 18:57:32 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


- Just a comment about versioning.
  Have the rpms a "snapshots" form of versioning?
  (https://docs.fedoraproject.org/en-US/packaging-guidelines/Versioning/#_snapshots)
  
  Why this date? 20210306 (6th March, 2021??)


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "the Unlicense", "Unknown or generated". 16 files have unknown
     license. Detailed output of licensecheck in
     /home/sagitter/1936138-wyhash/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in wyhash-
     devel
[ ]: Package functions as described.
[?]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: wyhash-devel-final1-1.20210306gitfinal.fc35.x86_64.rpm
          wyhash-doc-final1-1.20210306gitfinal.fc35.noarch.rpm
          wyhash-final1-1.20210306gitfinal.fc35.src.rpm
wyhash-devel.x86_64: W: spelling-error %description -l en_US wyrand -> randy
wyhash-devel.x86_64: W: spelling-error %description -l en_US practrand -> practiced
wyhash-devel.x86_64: W: spelling-error %description -l en_US endian -> Indian, ending
wyhash-devel.x86_64: W: no-documentation
wyhash-doc.noarch: W: spelling-error %description -l en_US wyrand -> randy
wyhash-doc.noarch: W: spelling-error %description -l en_US practrand -> practiced
wyhash-doc.noarch: W: spelling-error %description -l en_US endian -> Indian, ending
wyhash.src: W: spelling-error %description -l en_US wyrand -> randy
wyhash.src: W: spelling-error %description -l en_US practrand -> practiced
wyhash.src: W: spelling-error %description -l en_US endian -> Indian, ending
3 packages and 0 specfiles checked; 0 errors, 10 warnings.




Rpmlint (installed packages)
----------------------------
wyhash-devel.x86_64: W: spelling-error %description -l en_US wyrand -> randy
wyhash-devel.x86_64: W: spelling-error %description -l en_US practrand -> practiced
wyhash-devel.x86_64: W: spelling-error %description -l en_US endian -> Indian, ending
wyhash-devel.x86_64: W: no-documentation
wyhash-doc.noarch: W: spelling-error %description -l en_US wyrand -> randy
wyhash-doc.noarch: W: spelling-error %description -l en_US practrand -> practiced
wyhash-doc.noarch: W: spelling-error %description -l en_US endian -> Indian, ending
2 packages and 0 specfiles checked; 0 errors, 7 warnings.



Source checksums
----------------
https://github.com/wangyi-fudan/wyhash/archive/wyhash_final/wyhash-wyhash_final.tar.gz :
  CHECKSUM(SHA256) this package     : d685c763b06b1a0485c09baa1dd752538ba192a6d270e52d1bfd2053d83024d8
  CHECKSUM(SHA256) upstream package : d685c763b06b1a0485c09baa1dd752538ba192a6d270e52d1bfd2053d83024d8


Requires
--------
wyhash-devel (rpmlib, GLIBC filtered):

wyhash-doc (rpmlib, GLIBC filtered):



Provides
--------
wyhash-devel:
    wyhash-devel
    wyhash-devel(x86-64)
    wyhash-static
    wyhash_final1-devel
    wyhash_final1-devel(x86-64)
    wyhash_final1-static

wyhash-doc:
    wyhash-doc



Generated by fedora-review 0.7.6 (b083f91) last change: 2020-11-10
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1936138
Buildroot used: fedora-rawhide-x86_64
Active plugins: C/C++, Generic, Shell-api
Disabled plugins: Python, Ocaml, fonts, R, Haskell, SugarActivity, PHP, Java, Perl
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 2 Ben Beasley 2021-03-08 19:33:06 UTC
> - Just a comment about versioning.
>   Have the rpms a "snapshots" form of versioning?
>   (https://docs.fedoraproject.org/en-US/packaging-guidelines/Versioning/#_snapshots)

Yes, when you use the “forge” macros with a tag (https://docs.fedoraproject.org/en-US/packaging-guidelines/SourceURL/#_tag_example), they automatically add a “snapshot” date. Unfortunately, the release template (https://docs.fedoraproject.org/en-US/packaging-guidelines/SourceURL/#_release_example), which would not do this, very rarely works.

Packaging variables read or set by %forgemeta
  forgeurl:          https://github.com/wangyi-fudan/wyhash
  forgesource:       https://github.com/wangyi-fudan/wyhash/archive/wyhash_final/wyhash-wyhash_final.tar.gz
  forgesetupargs:    -n wyhash-wyhash_final
  archivename:       wyhash-wyhash_final
  archiveext:        tar.gz
  archiveurl:        https://github.com/wangyi-fudan/wyhash/archive/wyhash_final/wyhash-wyhash_final.tar.gz
  topdir:            wyhash-wyhash_final
  extractdir:        wyhash-wyhash_final
  repo:              wyhash
  scm:               git
  tag:               wyhash_final
  distprefix:        .20210306gitfinal
  dist:              .20210306gitfinal.fc33
  (snapshot date is either manually supplied or computed once %{_sourcedir}/%{archivename}.%{archiveext} is available)

It’s possible to work around drop the forge macros and construct the tag archive URL manually, e.g. https://github.com/wangyi-fudan/%{name}/archive/%{tag}.tar.gz.

>   Why this date? 20210306 (6th March, 2021??)

It’s coming from the mtime on the source tarball.

Comment 3 Ben Beasley 2021-03-08 19:36:41 UTC
Actually, I guess that

  %global distprefix %{nil}

before %forgemeta should prevent the snapshot versioning too.

Comment 4 Antonio T. sagitter 2021-03-08 20:31:29 UTC
Package approved.

Comment 5 Ben Beasley 2021-03-09 13:16:36 UTC
Thanks for the review!

Comment 6 Tomas Hrcka 2021-03-10 22:43:54 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/wyhash

Comment 7 Fedora Update System 2021-03-11 13:13:46 UTC
FEDORA-2021-e2e8e66542 has been submitted as an update to Fedora 34. https://bodhi.fedoraproject.org/updates/FEDORA-2021-e2e8e66542

Comment 8 Fedora Update System 2021-03-11 13:22:08 UTC
FEDORA-2021-46a6447f0d has been submitted as an update to Fedora 33. https://bodhi.fedoraproject.org/updates/FEDORA-2021-46a6447f0d

Comment 9 Fedora Update System 2021-03-11 13:30:22 UTC
FEDORA-2021-f12fb41198 has been submitted as an update to Fedora 32. https://bodhi.fedoraproject.org/updates/FEDORA-2021-f12fb41198

Comment 10 Fedora Update System 2021-03-11 13:37:58 UTC
FEDORA-EPEL-2021-7b083bc867 has been submitted as an update to Fedora EPEL 8. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2021-7b083bc867

Comment 11 Fedora Update System 2021-03-11 19:51:55 UTC
FEDORA-2021-e2e8e66542 has been pushed to the Fedora 34 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-e2e8e66542 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-e2e8e66542

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 12 Fedora Update System 2021-03-12 00:18:07 UTC
FEDORA-EPEL-2021-7b083bc867 has been pushed to the Fedora EPEL 8 testing repository.

You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2021-7b083bc867

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 13 Fedora Update System 2021-03-12 00:19:18 UTC
FEDORA-2021-46a6447f0d has been pushed to the Fedora 33 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-46a6447f0d \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-46a6447f0d

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 14 Fedora Update System 2021-03-12 00:21:26 UTC
FEDORA-2021-f12fb41198 has been pushed to the Fedora 32 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-f12fb41198 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-f12fb41198

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 15 Fedora Update System 2021-03-19 18:49:06 UTC
FEDORA-2021-46a6447f0d has been pushed to the Fedora 33 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 16 Fedora Update System 2021-03-19 18:52:17 UTC
FEDORA-2021-f12fb41198 has been pushed to the Fedora 32 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 17 Fedora Update System 2021-03-19 20:11:44 UTC
FEDORA-2021-e2e8e66542 has been pushed to the Fedora 34 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 18 Fedora Update System 2021-03-27 00:29:34 UTC
FEDORA-EPEL-2021-7b083bc867 has been pushed to the Fedora EPEL 8 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.